local BEC = BuffEnough

BEC.ClassBuffLevels = {}

BEC.ClassBuffLevels.Druid = nil

BEC.ClassBuffLevels.Hunter = {
	{
		-- Aspects: So as to not dictate an aspect, these will all be loaded together, except for Aspect of the Cheetah, Pack and Beast.
		["SpellList"] = {
			{["Level"] = 4, ["Until"] = 71, ["SpellIDs"] = {13163}}, -- Monkey
			{["Level"] = 10, ["Until"] = 18, ["SpellIDs"] = {13165}}, -- Hawk 1
			{["Level"] = 18, ["Until"] = 28, ["SpellIDs"] = {14318}}, -- Hawk 2
			{["Level"] = 28, ["Until"] = 338, ["SpellIDs"] = {14319}}, -- Hawk 3
			{["Level"] = 38, ["Until"] = 48, ["SpellIDs"] = {14320}}, -- Hawk 4
			{["Level"] = 46, ["Until"] = 56, ["SpellIDs"] = {20043}}, -- Wild 1
			{["Level"] = 48, ["Until"] = 58, ["SpellIDs"] = {14321}}, -- Hawk 5
			{["Level"] = 56, ["Until"] = 68, ["SpellIDs"] = {20190}}, -- Wild 2
			{["Level"] = 58, ["Until"] = 60, ["SpellIDs"] = {14322}}, -- Hawk 6
			{["Level"] = 60, ["Until"] = 68, ["SpellIDs"] = {25296}}, -- Hawk 7
			{["Level"] = 64, ["Until"] = 71, ["SpellIDs"] = {34074}}, -- Viper 1
			{["Level"] = 68, ["Until"] = 71, ["SpellIDs"] = {27045}}, -- Wild 3
			{["Level"] = 68, ["Until"] = 71, ["SpellIDs"] = {27044}} -- Hawk 8
		},
		["Name"] = "Hunter Aspect",
		["MaxNeeded"] = 1,
		["Optional"] = false
	}
}

BEC.ClassBuffLevels.Mage = {
	{
		-- Mage Armors: Molten, Mage, Ice, Frost
		["SpellList"] = {
			{["Level"] = 1, ["Until"] = 10, ["SpellIDs"] = {168}}, -- Frost Armor 1
			{["Level"] = 10, ["Until"] = 20, ["SpellIDs"] = {7300}}, -- Frost Armor 2
			{["Level"] = 20, ["Until"] = 30, ["SpellIDs"] = {7301}}, -- Frost Armor 3
			{["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {7302}}, -- Ice Armor 1
			{["Level"] = 34, ["Until"] = 46, ["SpellIDs"] = {6117}}, -- Mage Armor 1
			{["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {7320}}, -- Ice Armor 2
			{["Level"] = 46, ["Until"] = 58, ["SpellIDs"] = {22782}}, -- Mage Armor 2
			{["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {10219}}, -- Ice Armor 3
			{["Level"] = 58, ["Until"] = 69, ["SpellIDs"] = {22783}}, -- Mage Armor 3
			{["Level"] = 60, ["Until"] = 69, ["SpellIDs"] = {10220}}, -- Ice Armor 4
			{["Level"] = 62, ["Until"] = 71, ["SpellIDs"] = {30482}}, -- Molten Armor 1
			{["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {27124}}, -- Ice Armor 5
			{["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {27125}} -- Mage Armor 4
		},
		["Name"] = "Armor Buff",
		["MaxNeeded"] = 1,
		["Optional"] = false
	}
}

BEC.ClassBuffLevels.Paladin = {
	{
		-- Paladin Auras
		["SpellList"] = {
			{["Level"] = 2, ["Until"] = 10, ["SpellIDs"] = {465}}, -- Devotion Aura 1
			{["Level"] = 10, ["Until"] = 20, ["SpellIDs"] = {10290}}, -- Devotion Aura 2
			{["Level"] = 16, ["Until"] = 26, ["SpellIDs"] = {7924}}, -- Retribution Aura 1
			{["Level"] = 20, ["Until"] = 30, ["SpellIDs"] = {643}}, -- Devotion Aura 3
			{["Level"] = 22, ["Until"] = 71, ["SpellIDs"] = {19746}}, -- Concentration Aura
			{["Level"] = 26, ["Until"] = 36, ["SpellIDs"] = {10298}}, -- Retribution Aura 2
			{["Level"] = 28, ["Until"] = 40, ["SpellIDs"] = {19876}}, -- Shadow Resistance Aura 1
			{["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {10291}}, -- Devotion Aura 4
			{["Level"] = 30, ["Until"] = 71, ["SpellIDs"] = {20218}}, -- Sanctity Aura
			{["Level"] = 32, ["Until"] = 44, ["SpellIDs"] = {19888}}, -- Frost Resistance Aura 1
			{["Level"] = 36, ["Until"] = 46, ["SpellIDs"] = {10299}}, -- Retribution Aura 3
			{["Level"] = 36, ["Until"] = 48, ["SpellIDs"] = {19891}}, -- Fire Resistance Aura 1
			{["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {1032}}, -- Devotion Aura 5
			{["Level"] = 40, ["Until"] = 52, ["SpellIDs"] = {19895}}, -- Shadow Resistance Aura 2
			{["Level"] = 44, ["Until"] = 56, ["SpellIDs"] = {19897}}, -- Frost Resistance Aura 2
			{["Level"] = 46, ["Until"] = 56, ["SpellIDs"] = {10300}}, -- Retribution Aura 4
			{["Level"] = 48, ["Until"] = 60, ["SpellIDs"] = {19899}}, -- Fire Resistance Aura 2
			{["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {10292}}, -- Devotion Aura 6
			{["Level"] = 52, ["Until"] = 63, ["SpellIDs"] = {19896}}, -- Shadow Resistance Aura 3
			{["Level"] = 56, ["Until"] = 66, ["SpellIDs"] = {10301}}, -- Retribution Aura 5
			{["Level"] = 56, ["Until"] = 68, ["SpellIDs"] = {19898}}, -- Frost Resistance Aura 3
			{["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {10293}}, -- Devotion Aura 7
			{["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {19900}}, -- Fire Resistance Aura 3
			{["Level"] = 63, ["Until"] = 71, ["SpellIDs"] = {27151}}, -- Shadow Resistance Aura 4
			{["Level"] = 66, ["Until"] = 71, ["SpellIDs"] = {27150}}, -- Retribution Aura 6
			{["Level"] = 68, ["Until"] = 71, ["SpellIDs"] = {27152}}, -- Frost Resistance Aura 4
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27149}}, -- Devotion Aura 8
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27153}} -- Fire Resistance Aura 4
		},
		["Name"] = "Paladin Aura",
		["MaxNeeded"] = 1,
		["Optional"] = false
	},
	{
		-- Paladin Seals
		["SpellList"] = {
			{["Level"] = 1, ["Until"] = 10, ["SpellIDs"] = {21084}}, -- Seal of Righteousness 1
			{["Level"] = 6, ["Until"] = 12, ["SpellIDs"] = {21082}}, -- Seal of the Crusader 1
			{["Level"] = 10, ["Until"] = 18, ["SpellIDs"] = {20287}}, -- Seal of Righteousness 2
			{["Level"] = 12, ["Until"] = 22, ["SpellIDs"] = {20162}}, -- Seal of the Crusader 2
			{["Level"] = 18, ["Until"] = 26, ["SpellIDs"] = {20288}}, -- Seal of Righteousness 3
			{["Level"] = 20, ["Until"] = 30, ["SpellIDs"] = {20375}}, -- Seal of Command 1
			{["Level"] = 22, ["Until"] = 48, ["SpellIDs"] = {20164}}, -- Seal of Justice 1
			{["Level"] = 22, ["Until"] = 32, ["SpellIDs"] = {20305}}, -- Seal of the Crusader 3
			{["Level"] = 26, ["Until"] = 34, ["SpellIDs"] = {20289}}, -- Seal of Righteousness 4
			{["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {20915}}, -- Seal of Command 2
			{["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {20165}}, -- Seal of Light 1
			{["Level"] = 32, ["Until"] = 42, ["SpellIDs"] = {20306}}, -- Seal of the Crusader 4
			{["Level"] = 34, ["Until"] = 42, ["SpellIDs"] = {20290}}, -- Seal of Righteousness 5
			{["Level"] = 38, ["Until"] = 48, ["SpellIDs"] = {20166}}, -- Seal of Wisdom 1
			{["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {20918}}, -- Seal of Command 3
			{["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {20347}}, -- Seal of Light 2
			{["Level"] = 42, ["Until"] = 50, ["SpellIDs"] = {20291}}, -- Seal of Righteousness 6
			{["Level"] = 42, ["Until"] = 52, ["SpellIDs"] = {20307}}, -- Seal of the Crusader 5
			{["Level"] = 48, ["Until"] = 58, ["SpellIDs"] = {20356}}, -- Seal of Wisdom 2
			{["Level"] = 48, ["Until"] = 71, ["SpellIDs"] = {31895}}, -- Seal of Justice 2
			{["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {20919}}, -- Seal of Command 4
			{["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {20348}}, -- Seal of Light 3
			{["Level"] = 50, ["Until"] = 58, ["SpellIDs"] = {20292}}, -- Seal of Righteousness 7
			{["Level"] = 52, ["Until"] = 61, ["SpellIDs"] = {20308}}, -- Seal of the Crusader 6
			{["Level"] = 58, ["Until"] = 66, ["SpellIDs"] = {20293}}, -- Seal of Righteousness 8
			{["Level"] = 58, ["Until"] = 67, ["SpellIDs"] = {20357}}, -- Seal of Wisdom 3
			{["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {20920}}, -- Seal of Command 5
			{["Level"] = 60, ["Until"] = 69, ["SpellIDs"] = {20349}}, -- Seal of Light 4
			{["Level"] = 61, ["Until"] = 71, ["SpellIDs"] = {27158}}, -- Seal of the Crusader 7
			{["Level"] = 64, ["Until"] = 71, ["SpellIDs"] = {31892}}, -- Seal of Blood 1
			{["Level"] = 64, ["Until"] = 71, ["SpellIDs"] = {31801}}, -- Seal of Vengeance
			{["Level"] = 66, ["Until"] = 71, ["SpellIDs"] = {27155}}, -- Seal of Righteousness 9
			{["Level"] = 67, ["Until"] = 71, ["SpellIDs"] = {27166}}, -- Seal of Wisdom 4
			{["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {27160}}, -- Seal of Light 5
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27170}}, -- Seal of Command 6
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {348704}}, -- Seal of Corruption 1
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {348700}} -- Seal of the Martyr 1
		},
		["Name"] = "Paladin Seal",
		["MaxNeeded"] = 1,
		["Optional"] = true
	}
}

BEC.ClassBuffLevels.Priest = {
	{
		["SpellList"] = {
			{["Level"] = 12, ["Until"] = 20, ["SpellIDs"] = {588}},
			{["Level"] = 20, ["Until"] = 30, ["SpellIDs"] = {7128}},
			{["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {602}},
			{["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {1006}},
			{["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {10951}},
			{["Level"] = 60, ["Until"] = 69, ["SpellIDs"] = {10952}},
			{["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {25431}}
		},
		["Name"] = "Inner Fire",
		["MaxNeeded"] = 1,
		["Optional"] = true
	}
}

BEC.ClassBuffLevels.Rogue = {
	{
		-- Slice and Dice
		["SpellList"] = {
			{["Level"] = 10, ["Until"] = 42, ["SpellIDs"] = {5171}},
			{["Level"] = 42, ["Until"] = 71, ["SpellIDs"] = {6774}}
		},
		["Name"] = "Slice and Dice",
		["MaxNeeded"] = 1,
		["Optional"] = true
	}
}

BEC.ClassBuffLevels.Shaman = {
	{
		-- Shield Buff
		["SpellList"] = {
			{["Level"] = 8, ["Until"] = 16, ["SpellIDs"] = {324}},
			{["Level"] = 16, ["Until"] = 24, ["SpellIDs"] = {325}},
			{["Level"] = 24, ["Until"] = 32, ["SpellIDs"] = {905}},
			{["Level"] = 32, ["Until"] = 40, ["SpellIDs"] = {945}},
			{["Level"] = 40, ["Until"] = 48, ["SpellIDs"] = {8134}},
			{["Level"] = 48, ["Until"] = 56, ["SpellIDs"] = {10431}},
			{["Level"] = 56, ["Until"] = 63, ["SpellIDs"] = {10432}},
			{["Level"] = 62, ["Until"] = 69, ["SpellIDs"] = {24398}},
			{["Level"] = 63, ["Until"] = 70, ["SpellIDs"] = {25469}},
			{["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {33736}},
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {25472}}
		},
		["Name"] = "Shield Buff",
		["MaxNeeded"] = 1,
		["Optional"] = false
	}
	--[[, {
		-- TODO: Work out how to scan weapons for buffs.
		-- TODO: Reverse Order to Ascending
		-- Weapon Buff
		["Levels"] = {
			{["Level"] = 70, ["SpellIDs"] = {25485,25489,25505,25500}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 68, ["SpellIDs"] = {25479,25489,25505,25500}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 66, ["SpellIDs"] = {25479,25489,16362,25500}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 64, ["SpellIDs"] = {25479,25489,16362,16356}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 62, ["SpellIDs"] = {25479,16342,16362,16356}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 60, ["SpellIDs"] = {16316,16342,16362,16356}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 58, ["SpellIDs"] = {16316,16342,10486,16356}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 56, ["SpellIDs"] = {16316,16342,10486,16355}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 54, ["SpellIDs"] = {16316,16341,10486,16355}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 50, ["SpellIDs"] = {16315,16341,10486,16355}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 48, ["SpellIDs"] = {16315,16341,8235,16355}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 46, ["SpellIDs"] = {16315,16341,8235,10456}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 44, ["SpellIDs"] = {16315,16339,8235,10456}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 40, ["SpellIDs"] = {16314,16339,8235,10456}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 38, ["SpellIDs"] = {16314,16339,8232,10456}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 36, ["SpellIDs"] = {16314,16339,8232,8038}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 34, ["SpellIDs"] = {16314,8030,8232,8038}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 30, ["SpellIDs"] = {10399,8030,8232,8038}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 28, ["SpellIDs"] = {10399,8030,8038}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 26, ["SpellIDs"] = {10399,8030,8033}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 24, ["SpellIDs"] = {10399,8027,8033}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 20, ["SpellIDs"] = {8019,8027,8033}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 18, ["SpellIDs"] = {8019,8027}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 16, ["SpellIDs"] = {8019,8024}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 10, ["SpellIDs"] = {8018,8024}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 8, ["SpellIDs"] = {8018}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"},
			{["Level"] = 1, ["SpellIDs"] = {8017}, ["Required"] = false, ["DisplayText"] = "Weapon Buff"}

		}
	} ]]
}

BEC.ClassBuffLevels.Warlock = {
	{
		-- Demon/Fel Armor
		["SpellList"] = {
			{["Level"] = 20, ["Until"] = 30, ["SpellIDs"] = {706}},
			{["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {1086}},
			{["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {11733}},
			{["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {11734}},
			{["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {11735}},
			{["Level"] = 62, ["Until"] = 69, ["SpellIDs"] = {28176}},
			{["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {28189}},
			{["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27260}}
		},
		["Name"] = "Armor Buff",
		["MaxNeeded"] = 1,
		["Optional"] = false
	}
}

BEC.ClassBuffLevels.Warrior = nil
-- TODO: Determine how to check active Stance, using Shapeshift form.
--[[ {
		-- Stance
		["Levels"] = {
			{["Level"]=1,["SpellIDs"] = {2457,71,2458}, ["Required"] = true, ["DisplayText"] = "Warrior Stance"},
			{["Level"]=1,["SpellIDs"] = {2457,71}, ["Required"] = true, ["DisplayText"] = "Warrior Stance"},
			{["Level"]=1,["SpellIDs"] = {2457}, ["Required"] = true, ["DisplayText"] = "Battle Stance"}
		}
	}
} ]]
-- GetPlayerClassBuffs(classID)
-- classID : The ID representation of the class.
-- Returns : The array of class buffs.
function BEC:GetPlayerClassBuffs(classID)
	if classID == BEC.Class.Druid then
		return BEC.ClassBuffLevels.Druid
	elseif classID == BEC.Class.Hunter then
		return BEC.ClassBuffLevels.Hunter
	elseif classID == BEC.Class.Mage then
		return BEC.ClassBuffLevels.Mage
	elseif classID == BEC.Class.Paladin then
		return BEC.ClassBuffLevels.Paladin
	elseif classID == BEC.Class.Priest then
		return BEC.ClassBuffLevels.Priest
	elseif classID == BEC.Class.Rogue then
		return BEC.ClassBuffLevels.Rogue
	elseif classID == BEC.Class.Shaman then
		return BEC.ClassBuffLevels.Shaman
	elseif classID == BEC.Class.Warlock then
		return BEC.ClassBuffLevels.Warlock
	elseif classID == BEC.Class.Warrior then
		return BEC.ClassBuffLevels.Warrior
	end

	return nil
end
