local BEC = BuffEnough

BEC.PaladinBuffType =
    BEC:enum(
    {
        "Might",
        "Kings",
        "Wisdom",
        "Salvation",
        "Sanctuary"
    }
)

BEC.IntellectSpellIDs = {
    {["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27126, 27127}},
    {["Level"] = 56, ["Until"] = 70, ["SpellIDs"] = {10157, 23028}},
    {["Level"] = 42, ["Until"] = 56, ["SpellIDs"] = {10156}},
    {["Level"] = 28, ["Until"] = 42, ["SpellIDs"] = {1461}},
    {["Level"] = 14, ["Until"] = 28, ["SpellIDs"] = {1460}},
    {["Level"] = 1, ["Until"] = 14, ["SpellIDs"] = {1459}}
}

BEC.StaminaSpellIDs = {
    {["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {25389, 25392}},
    {["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {10938, 21564}},
    {["Level"] = 48, ["Until"] = 60, ["SpellIDs"] = {10937, 21562}},
    {["Level"] = 36, ["Until"] = 48, ["SpellIDs"] = {2791}},
    {["Level"] = 24, ["Until"] = 36, ["SpellIDs"] = {1245}},
    {["Level"] = 12, ["Until"] = 24, ["SpellIDs"] = {1244}},
    {["Level"] = 1, ["Until"] = 12, ["SpellIDs"] = {1243}}
}

BEC.StatsSpellIDs = {
    {["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {26990, 26991}},
    {["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {9885, 21850}},
    {["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {9884, 21849}},
    {["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {8907}},
    {["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {5234}},
    {["Level"] = 20, ["Until"] = 30, ["SpellIDs"] = {6756}},
    {["Level"] = 10, ["Until"] = 20, ["SpellIDs"] = {5232}},
    {["Level"] = 1, ["Until"] = 10, ["SpellIDs"] = {1126}}
}

BEC.ThornsSpellIDs = {
    {["Level"] = 64, ["Until"] = 71, ["SpellIDs"] = {26992}},
    {["Level"] = 54, ["Until"] = 64, ["SpellIDs"] = {9910}},
    {["Level"] = 44, ["Until"] = 54, ["SpellIDs"] = {9756}},
    {["Level"] = 34, ["Until"] = 44, ["SpellIDs"] = {8914}},
    {["Level"] = 24, ["Until"] = 34, ["SpellIDs"] = {1075}},
    {["Level"] = 14, ["Until"] = 24, ["SpellIDs"] = {782}},
    {["Level"] = 6, ["Until"] = 14, ["SpellIDs"] = {467}}
}

--[[ 
    Greater Sanc 1,2
    Blessing of Light  
    Greater Light
]]
BEC.BlessingOfKingsSpellIDs = {
    {["Level"] = 60, ["Until"] = 71, ["SpellIDs"] = {25898}},
    {["Level"] = 21, ["Until"] = 71, ["SpellIDs"] = {20217}}
}

BEC.BlessingOfMightSpellIDs = {
    {["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27140, 27141}},
    {["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {25916, 25291}},
    {["Level"] = 52, ["Until"] = 60, ["SpellIDs"] = {25782, 19838}},
    {["Level"] = 42, ["Until"] = 52, ["SpellIDs"] = {19837}},
    {["Level"] = 32, ["Until"] = 42, ["SpellIDs"] = {19836}},
    {["Level"] = 22, ["Until"] = 32, ["SpellIDs"] = {19835}},
    {["Level"] = 12, ["Until"] = 22, ["SpellIDs"] = {19834}},
    {["Level"] = 4, ["Until"] = 12, ["SpellIDs"] = {19740}}
}

BEC.BlessingOfWisdomSpellIDs = {
    {["Level"] = 65, ["Until"] = 71, ["SpellIDs"] = {27142, 27143}},
    {["Level"] = 60, ["Until"] = 65, ["SpellIDs"] = {25918, 25290}},
    {["Level"] = 54, ["Until"] = 60, ["SpellIDs"] = {25894, 19854}},
    {["Level"] = 44, ["Until"] = 54, ["SpellIDs"] = {19853}},
    {["Level"] = 34, ["Until"] = 44, ["SpellIDs"] = {19852}},
    {["Level"] = 24, ["Until"] = 34, ["SpellIDs"] = {19850}},
    {["Level"] = 14, ["Until"] = 24, ["SpellIDs"] = {19742}}
}

BEC.BlessingOfSalvationSpellIDs = {
    {["Level"] = 60, ["Until"] = 71, ["SpellIDs"] = {25895}},
    {["Level"] = 26, ["Until"] = 71, ["SpellIDs"] = {1038}}
}

BEC.BlessingOfSanctuarySpellIDs = {
    {["Level"] = 70, ["Until"] = 71, ["SpellIDs"] = {27168, 27169}},
    {["Level"] = 60, ["Until"] = 70, ["SpellIDs"] = {20914, 25899}},
    {["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {20913}},
    {["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {20912}},
    {["Level"] = 30, ["Until"] = 40, ["SpellIDs"] = {20911}}
}

BEC.BlessingOfLightSpellIDs = {
    {["Level"] = 69, ["Until"] = 71, ["SpellIDs"] = {27144, 27145}},
    {["Level"] = 60, ["Until"] = 69, ["SpellIDs"] = {19979, 25890}},
    {["Level"] = 50, ["Until"] = 60, ["SpellIDs"] = {19978}},
    {["Level"] = 40, ["Until"] = 50, ["SpellIDs"] = {19977}}
}

function BEC:CanUseBlessing(playerClassID, playerSpecID, blessingType)
    if blessingType == BEC.PaladinBuffType.Might then
        return BEC:SetContains(
            {
                BEC.Class.Warrior,
                BEC.Class.Rogue,
                BEC.Class.DemonHunter,
                BEC.Class.DeathKnight,
                BEC.Class.Hunter
            },
            playerClassID
        ) or
            BEC:SetContains(
                {BEC.ClassSpec.DruidFeral, BEC.ClassSpec.PaladinProtection, BEC.ClassSpec.PaladinRetribution, BEC.ClassSpec.ShamanEnhancement},
                playerSpecID
            ) or
            (playerSpecID == 0 and BEC:SetContains({BEC.Class.Druid, BEC.Class.Paladin, BEC.Class.Shaman}, playerClassID))
    elseif blessingType == BEC.PaladinBuffType.Wisdom then
        return BEC:HasMana(playerClassID, playerSpecID)
    elseif blessingType == BEC.PaladinBuffType.Sanctuary then
        return BEC:SetContains({BEC.ClassSpec.PaladinProtection, BEC.ClassSpec.WarriorProtection, BEC.ClassSpec.DruidFeral}, playerSpecID) or
            (playerSpecID == 0 and BEC:SetContains({BEC.Class.Druid, BEC.Class.Paladin, BEC.Class.Warrior}, playerClassID))
    elseif blessingType == BEC.PaladinBuffType.Salvation then
        return not BEC:SetContains({BEC.ClassSpec.PaladinProtection, BEC.ClassSpec.WarriorProtection, BEC.ClassSpec.DruidFeral}, playerSpecID)
    else
        return true
    end
end

function BEC:HasMana(playerClassID, playerSpecID)
    if
        BEC:SetContains(
            {
                BEC.Class.Warrior,
                BEC.Class.Rogue,
                BEC.Class.DemonHunter,
                BEC.Class.DeathKnight
            },
            playerClassID
        )
     then
        return false
    elseif BEC:SetContains({}, playerSpecID) then
        return false
    else
        return true
    end
end

function BEC:GetGroupBuffSetup(groupComp)
    local rc = {}

    if BEC:HasMana(groupComp.PlayerClassID, groupComp.PlayerSpecID) and groupComp.MaxMageLevel >= 1 then
        table.insert(rc, {["SpellList"] = BEC.IntellectSpellIDs, ["Name"] = "Arcane Intellect", ["CasterLevels"] = {groupComp.MaxMageLevel}, ["MaxNeeded"] = 1})
    end

    if groupComp.MaxDruidLevel >= 1 then
        table.insert(rc, {["SpellList"] = BEC.StatsSpellIDs, ["Name"] = "Mark of the Wild", ["CasterLevels"] = {groupComp.MaxDruidLevel}, ["MaxNeeded"] = 1})
    end

    if groupComp.MaxPriestLevel >= 1 then
        table.insert(
            rc,
            {["SpellList"] = BEC.StaminaSpellIDs, ["Name"] = "Power Word: Fortitude", ["CasterLevels"] = {groupComp.MaxPriestLevel}, ["MaxNeeded"] = 1}
        )
    end

    if BuffEnoughClassic_Settings.ShouldCheckThorns and groupComp.MaxDruidLevel >= 6 then
        table.insert(rc, {["SpellList"] = BEC.ThornsSpellIDs, ["Name"] = "Thorns", ["CasterLevels"] = {groupComp.MaxDruidLevel}, ["MaxNeeded"] = 1})
    end

    if table.getn(groupComp.PaladinLevels) > 0 then
        local pallySpellList = {}
        local blessingCount = 2

        BEC:AddSetToSet(pallySpellList, BEC.BlessingOfKingsSpellIDs)
        BEC:AddSetToSet(pallySpellList, BEC.BlessingOfLightSpellIDs)

        -- Tanks
        if BEC:CanUseBlessing(groupComp.PlayerClassID, groupComp.PlayerSpecID, BEC.PaladinBuffType.Sanctuary) then
            BEC:DebugUpdatePrint("Can use Sanctuary")
            BEC:AddSetToSet(pallySpellList, BEC.BlessingOfSanctuarySpellIDs)
            blessingCount = blessingCount + 1
        end

        -- Mana Users
        if BEC:CanUseBlessing(groupComp.PlayerClassID, groupComp.PlayerSpecID, BEC.PaladinBuffType.Wisdom) then
            BEC:DebugUpdatePrint("Can use Wisdom")
            BEC:AddSetToSet(pallySpellList, BEC.BlessingOfWisdomSpellIDs)
            blessingCount = blessingCount + 1
        end

        -- Physical Damage Users
        if BEC:CanUseBlessing(groupComp.PlayerClassID, groupComp.PlayerSpecID, BEC.PaladinBuffType.Might) then
            BEC:DebugUpdatePrint("Can use Might")
            BEC:AddSetToSet(pallySpellList, BEC.BlessingOfMightSpellIDs)
            blessingCount = blessingCount + 1
        end

        if BEC:CanUseBlessing(groupComp.PlayerClassID, groupComp.PlayerSpecID, BEC.PaladinBuffType.Salvation) then
            BEC:DebugUpdatePrint("Can use Salvation")
            BEC:AddSetToSet(pallySpellList, BEC.BlessingOfSalvationSpellIDs)
            blessingCount = blessingCount + 1
        end

        table.insert(
            rc,
            {
                ["SpellList"] = pallySpellList,
                ["Name"] = "Paladin Buffs",
                ["CasterLevels"] = groupComp.PaladinLevels,
                ["MaxNeeded"] = blessingCount
            }
        )
    end

    return rc
end

